classdef SCDalgo_test < SCDtest
  
  properties (Abstract=true)
    algoobj function_handle % SCD algo obj name - abstract expects implementation by sub-class
  end
  
  properties (Hidden)
    algo SCDclass_algo
  end
  
  methods (TestClassSetup)
    function clear_base(testCase)
      % clear base workspace
      testCase.assertWarningFree(@() evalin('base','clear'));
    end
    
    function clear_sldd(testCase)
      SCD.clean_dd
      testCase.assertTrue(true);
    end
    
    function setup_conf(testCase)
      testCase.assertWarningFree(@() SCDconf_setConf('SIM'));
    end
    
    function setup_algo(testCase)
      % instantiate object
      testCase.algo = testCase.algoobj(); % call function handle to instantiate
      
      testCase.algo.init; % init data dictionary & fixed params
    end 
  end
  
  methods (TestClassTeardown)
    function close_dd(testCase) %#ok<MANU>
      Simulink.data.dictionary.closeAll('-discard');
    end
    
    function close_bd(testCase) %#ok<MANU>
      bdclose all;
    end
  end
  
  methods (Test,TestTags={'algos'})

    function test_printinfo(testCase)
      testCase.algo.printinfo;
    end
    
    function test_setup(testCase)
      testCase.algo.setup; % setup tunable parameters
    end
    
    function test_compile(testCase)
      testCase.algo.compile; % update model (Ctrl-D) Simulink
    end
    
    function test_test_harness(testCase)
      testCase.algo.test_harness;
    end
  end
  
end